package eu.mhsl.craftattack.teamLobby.util;

import eu.mhsl.craftattack.teamLobby.http.ReqResp;
import eu.mhsl.craftattack.teamLobby.http.Request;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.minestom.server.MinecraftServer;
import net.minestom.server.entity.Player;
import net.minestom.server.timer.TaskSchedule;

import java.net.http.HttpRequest;

public class ConnectInfo {
    public static int availableTickets = 0;
    public static void tickets(String teamName, Player player) {
        var task = new Runnable() {
            @Override
            public void run() {
                HttpRequest request = Request.builder(Request.server(
                    "playtimer/tickets",
                    uriBuilder -> uriBuilder.addParameter("team", teamName)
                )).GET().build();

                record Ticket(String team, int tickets)  {}
                record Status(String status, Ticket response) {}
                ReqResp<Status> ticket = Request.execute(request, Status.class);
                availableTickets = ticket.data().response.tickets;

                MinecraftServer.getSchedulerManager().submitTask(
                    () -> {
                        String playtimeOverview = String.format(
                            "Dein Team hat noch %d Beitritte, also %dx%d=%d Minuten übrig.",
                            availableTickets,
                            availableTickets,
                            30,
                            availableTickets * 30
                        );
                        player.sendMessage(Component.text(playtimeOverview, NamedTextColor.DARK_GREEN));
                        return TaskSchedule.stop();
                    }
                );
            }
        };

        new Thread(task).start();
    }
}
